%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% getfreeresponse5ff
%%% Jason R. Finley
%%% jrfinley@uiuc.edu
%%% 07-19-02011
%%%
%%% Let's see if I can get this piece of crap working under Psych Toolbox 3!
%%% Woohoo.
%%%
%%% This freakin' thing draws a box and lets subjects type pretty much
%%% whatever they want into it, with no limit on length.  it captures what
%%% subjects type and returns that value as a string, 'subresponse.'
%%%
%%% --Designed to work on 1024x768 resolution.  MAY work on other resolutions.
%%%
%%% --backspace/delete is implemented (trust me, this alone was a huge pain in the ass).
%%%
%%% --typing multiple lines of text is implemented.
%%%
%%% --typing more lines than there are room to display in the box
%%% is implemented (previous lines 'scroll' up out of view, but will 'come
%%% back' into view if enough lines are deleted to make room in the box again).
%%%
%%% --when subjects hit ENTER (or RETURN, i think), an alert
%%% appears to give them a choice of going back and continuing to type, or
%%% hitting ENTER again and submitting their response.
%%%
%%% --WORD WRAP IS NOW IMPLEMENTED.  But if you type a word that gets
%%% wrapped onto the next line because of the last character, and then you
%%% delete the last character, that word will NOT go back up onto the
%%% previous line.  Hey I had to draw the line somewhere.
%%%
%%% --This function will also show a PROMPT/QUESTION above the responsebox.
%%%
%%% DEPENDENCIES:
%%%   Psychophysics Toolbox version 3
%%%   The following are from Cogtoolbox (~2011) compiled by Scott Fraundorf for Aaron Benjamin's lab (adapted from work by Mike Diaz):
%%%     FilledRect
%%%     FramedRect
%%%     WriteLine
%%%     WriteLeft
%%%     WriteCentered
%%%     Wait4Key
%%%     strtokMultiple
%%%
%%% KNOWN ISSUES:
%%%   --If prompt is too long, there won't be enough space to make a response
%%%     box on the screen and this function will probably crash.
%%%   --If you try to type one lonnnnng word with no spaces that exceeds
%%%     the width of the response box, this will probably break word wrap and
%%%     crash the function.
%%%   --If you use a ridiculously huge textsize, it will probably break.
%%%   --The code is kind of a mess.  Trust me, I'm as bummed out about that as you are.
%%%		Sorry.  Was trying to account for all the weird scenarios I could think of
%%%		and the code just got crazy.
%%%
%%% UNKNOWN ISSUES:
%%%   --Wish I knew.
%%%
%%% surf's up dudez
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



function subresponse=getfreeresponse5ff(prompt, window, textsize)
%'prompt' is the prompt or question you want to give subjects.
%'window' is a window where the subject's response will be displayed as s/he types.
%'textsize' is the size of the text for the subject's response.
%example call: subresponse=getfreeresponse5ff(prompt, w, 22);

FlushEvents('keyDown');  %necessary.  flushes any recently pressed keys (like in last few milliseconds) from memory buffer



%set colors used
white=WhiteIndex(window);
black=BlackIndex(window);

alphabetplus=['abcdefghijklmnopqrstuvwxyz0123456789!.?,-"/():;'' '];



enterkeynums=[3,10,13];
backspacekeynum=KbName('backspace');
spacekeynum=KbName('space');
escapekeynum=KbName('esc');
enterandescape=[enterkeynums escapekeynum];


xmargin=25;
xboxedge=50;
yprompttop=10;

%we'll just use 'x' and 'y' for shorthand.
x=xboxedge;
y=yprompttop;

%%%% WRITE PROMPT %%%%%
prompttextsize=26;
WordWrapNote='(Note: there is no word-wrap at the end of a line, so words you type may appear to be broken across two lines but this is not a problem.)';
Screen('TextSize',window,prompttextsize); %change text size for prompt
[newx,newy]=WriteLine(window,prompt,black,50,15,y,1.25);  %the last 4 arguments in this call are margin, x, y, and linespacing.  they mean 'margin to keep between left edge of text and position x, and right edge of text and right edge of screen', 'horizontal coordiante to start writing at', and 'vertical coordinate to start writing at.'
Screen('Flip',window,[],1);



%set text size to whatever you want to use for the subject's input to the response box
Screen('TextSize',window,textsize);  %hint: smaller text sizes will fit more characters per line and in the box total before line-scrolling.  but also they're harder to read!

y=newy+(prompttextsize*2); %now y will be the top of the responsebox.  I have to add to newy because WriteLine returns newy as the top of the last line of text it wrote.

%get screen height and width
[screenwidth, screenheight]=Screen('WindowSize', window);

%make the response rectangle/box below the prompt & word-wrap warning.
% coordinates key: r=[left top right bottom]
r=[x y screenwidth-x screenheight-75];

%draw border of responsebox
FilledRect(window, white, r);
FramedRect(window, black, r);
Screen('Flip',window,[],1);


%%making some useful variables to refer to sizes of the responsebox
subresponseboxwidth=r(3)-r(1);
subresponseboxheight=r(4)-r(2);
subresponseboxbottom=r(4);

bounds = Screen('TextBounds',window,'HWXjgqyQ');
height=bounds(4)-bounds(2); %determine how much further down each new line should be
offset=0; %offset is used kinda like, um, to keep track of where a cursor would be.  yeah.
subresponse=''; %subject response starts off as empty string.  during the main loop, it will only hold one line of text at a time, the current line, with any previous lines being stored in subresponselines.  at the end of the function, all lines are concatenated into one big long string, which subresponse then takes on the value of.
subresponselines={}; %subject response will fill up this matrix, with one line on each row, if it gets to be longer than one line
numscrolledlines=0;  %keeps track of the number of lines scrolled out of the top of the response box.  starts at 0.
originaly=y;  %save the y value in case we need it later.
x=x+xmargin;  %add the horizontal margin, passed in as an argument to this function, to the horizontal coordinate where letters will begin to appear when the subject types.
y=y+height;  %add height of a text line in the font being used to the vertical coordinate of where text will start appearing when subject starts to type.
currentword=''; %this keeps track of the word being currently typed, delimited by spaces.  this is used for word wrapping.
newcurrentword=true;
wrapword=false; %this will turn to true when it's time to wrap a word

while 1	% Loop forever until <return> or <enter> is hit
    [char,t]=GetChar; %%% HERE'S THE INPUT ACTION!!!!  THIS ONE LINE IS WHERE A KEY PRESSED BY THE SUBJECT IS INTERPRETED AS A CHARACTER.  This is a standard Psychtoolbox (PTB) function.  It works like gangbusters in PTB for Mac OS9 and Windows.  But the last I heard, in late 2006, GetChar still wasn't working reliably in Mac OSX.
    switch(abs(char))
        
        case num2cell(enterkeynums)	% if they hit <return> or <enter>   the numbers 13 and 3 are the kbnames for these keys, on Windows XP.  For some reason, the WinXP machine I have at my house as of 7/19/11 uses 10 as the value.
            %give them the ESCAPE vs CONFIRM ENTER alert when they first press ENTER
            oldFontSize=Screen('TextSize',window,24); %save currently-used fontsize
            Screen('TextStyle',window,1); %make text BOLD
            WriteCentered(window, 'Press ENTER again to confirm that you''re done typing,', screenwidth/2, screenheight-60, black);
            WriteCentered(window, 'or ESCAPE to continue typing. ', screenwidth/2, screenheight-30, black);
            Screen('Flip',window,[],1);
            Screen('TextStyle',window,0); %make text NOT BOLD
            Screen('TextSize',window,oldFontSize); %restore old font size
            [t keyCode]=Wait4Key(enterandescape);  %wait for enter/return or escape.  those numbers (13,3,10,27) are the 'kbnames' of the keys we're waiting for.
            if strcmp(KbName(keyCode),'return') || strcmp(KbName(keyCode),'enter')
                FlushEvents('keyDown'); % this has to be used after every call to Wait4Key
                break;   %they hit enter/return, so it's time to get the hell out!
            else  % they hit escape, so they can keep typing. remove the alert and keep looping
                FlushEvents('keyDown');
                FilledRect(window, white, [0,screenheight-75,screenwidth,screenheight]);
                Screen('Flip',window,[],1);
            end
            %end case enter/return
            
        case backspacekeynum			% if they hit backspace
            
            
            switch length(currentword)  %update currentword
                case 0 %this means they just deleted a space or that the response box was empty and they hit delete
                    currentword='';
                    newcurrentword=true;
                case 1 %there was only one character left in currentword
                    currentword='';
                    newcurrentword=true;
                otherwise %decrement currentword by one character
                    currentword=currentword(1:end-1);
            end
            
            
            if ~isempty(subresponse)  %if there are any characters in the current line of subresponse, then delete the one on the end.
                deletedChar = subresponse(end);
                subresponse=subresponse(1:end-1);
                bounds = Screen('TextBounds',window,deletedChar);  %this returns an array of left, top, right, bottom bounds of text. is slow.
                deletedwidth=bounds(3)-bounds(1);
                offset = offset - deletedwidth;
                Screen('Preference','TextAlphaBlending', 1); %Okay I'll be honest, I have no idea what this line actually does, but it enables me to use the tactic of writing over a character with white to 'delete' it.  Without this alphablending line, that tactic leaves a ghostly outline of the 'deleted' character.
                WriteLeft(window, deletedChar, x+offset, y, white); %write over the last character with white to delete it!
                Screen('Preference','TextAlphaBlending', 0);
                Screen('Flip',window,[],1);
                
                
                
                if newcurrentword %set new currentword
                    if ~isempty(subresponse) %if there are any characters left on the current line, set currentword to be the last word in this line.
                        if subresponse(end)==' '
                            %if the last character in the current line is
                            %now a space, don't set currentword yet.
                        else
                            WordsInCurrentLine = strtokMultiple(subresponse, ' '); %parse the current line into a cell array of words (delimited by space)
                            currentword=WordsInCurrentLine{end};
                            bounds = Screen('TextBounds',window,currentword);
                            newcurrentword=false;
                        end
                    elseif length(subresponselines)>=1 % if there AREN'T any characters left on the current line now, but there is at least one previous line, then get the new currentword out of that previous line.
                        %we're going to effectively have to move the
                        %cursor up at this point.
                        if numscrolledlines>0  %if we've scrolled at least one line out of the box yet, we gotta bring one back first
                            numscrolledlines=numscrolledlines-1;
                            FilledRect(window, white, [r(1)+2 r(2)+2 r(3)-2 r(4)-2]); %clear responsebox
                            Screen('Flip',window,[],1);
                            y=originaly+height;
                            offset=0;
                            
                            %write text of  lines all over again
                            offset=0;
                            for i=numscrolledlines+1:length(subresponselines)
                                WriteLeft(window, subresponselines{i}, x+offset, y, black);
                                y=y+height;
                            end
                            Screen('Flip',window,[],1);
                        end
                        %now update the subresponse variable to be the previous line, and
                        %shorten subresponselines by one
                        subresponse=subresponselines{end};
                        if length(subresponselines)==1
                            subresponselines={};
                        else
                            subresponselines=subresponselines(1:(end-1));
                        end
                        %the next few lines deal with repositioning coordinates to prepare for the next input.
                        y=y-height;
                        bounds = Screen('TextBounds',window,subresponse);
                        offset=bounds(3)-bounds(1);
                        
                        
                        if subresponse(end)==' '
                            %if the last character in the current line is
                            %now a space, don't set currentword yet.
                        else
                            WordsInCurrentLine = strtokMultiple(subresponse, ' '); %parse the current line into a cell array of words (delimited by space)
                            currentword=WordsInCurrentLine{end};
                            newcurrentword=false;
                        end
                    else
                        %nothing left in current line and there were no previous lines.
                        %keep the newcurrentword flag true.
                    end
                end %end setting on new currentword in case where there had been something on current line to be deleted
                
                
                
            elseif length(subresponselines)>=1 %if there are zero characters on current line of subresponse, but there are currently more than one line total in subresponse, then go back up a line and delete last char from that line
                
                if numscrolledlines>0  %if we've scrolled at least one line out of the box yet, we gotta bring one back first
                    numscrolledlines=numscrolledlines-1;
                    FilledRect(window, white, [r(1)+2 r(2)+2 r(3)-2 r(4)-2]); %clear responsebox
                    Screen('Flip',window,[],1);
                    y=originaly+height;
                    offset=0;
                    
                    %write text of  lines all over again
                    offset=0;
                    for i=numscrolledlines+1:length(subresponselines)
                        WriteLeft(window, subresponselines{i}, x+offset, y, black);
                        y=y+height;
                    end
                    Screen('Flip',window,[],1);
                    
                    
                end
                
                
                
                
                
                %now update the subresponse variable to be the previous line, and
                %shorten subresponselines by one
                subresponse=subresponselines{end};
                if length(subresponselines)==1
                    subresponselines={};
                else
                    subresponselines=subresponselines(1:(end-1));
                end
                %the next few lines deal with repositioning coordinates to prepare for the next input.
                y=y-height;
                bounds = Screen('TextBounds',window,subresponse);
                offset=bounds(3)-bounds(1);
                deletedChar = subresponse(end);
                bounds = Screen('TextBounds',window,deletedChar);
                deletedwidth=bounds(3)-bounds(1);
                subresponse=subresponse(1:end-1);
                offset = offset - deletedwidth;
                Screen('Preference','TextAlphaBlending', 1);
                WriteLeft(window, deletedChar, x+offset, y, white);
                Screen('Preference','TextAlphaBlending', 0);
                Screen('Flip',window,[],1);
                
                
                if newcurrentword %set new currentword
                    if subresponse(end)==' '
                        %if the last character in the current line is
                        %now a space, don't set currentword yet.
                    else
                        WordsInCurrentLine = strtokMultiple(subresponse, ' '); %parse the current line into a cell array of words (delimited by space)
                        currentword=WordsInCurrentLine{end};
                        newcurrentword=false;
                    end
                    
                end
                
            else
                %they hit backspace but there were no lines above and no characters in current line.  do nothing.
            end
            %end case backspace
            
        otherwise %they hit something beside enter or backspace
            
            
            if sum(lower(char)==alphabetplus)  %if the newletter appears in the acceptable keys
                
                if abs(char)==spacekeynum %if they hit the space bar, they've started a new word.
                    currentword='';
                    newcurrentword=true;
                    wrapword=false;
                else %add new char to currentword
                    currentword=[currentword char];
                    if newcurrentword
                        wrapword=false;
                        newcurrentword=false;
                    else
                        wrapword=true;  %only turn wrapword on if they just entered a non-space character AND this isn't a new currentword.
                    end
                end
                
                
                %this IF statement checks to see if the next typed char will
                %fit on the current line without running into the right side of the box.  if not, it's time to move down a line.
                bounds = Screen('TextBounds',window,[subresponse char]);
                if (bounds(3)-bounds(1))<=(subresponseboxwidth-1-xmargin)
                    subresponse=[subresponse char];  %add new letter to the string
                    WriteLeft(window, char, x+offset, y, black);
                    Screen('Flip',window,[],1);
                    bounds = Screen('TextBounds',window,char);
                    offset = offset + (bounds(3)-bounds(1));
                    
                else  %make new line...  and WORD WRAP!?!? if new character is anything but space.
                    
                    
                    
                    
                    if (y+(1.5*height))>=subresponseboxbottom %if the new line won't fit vertically in the box...
                        %no room in box for new line!  so we'll make it looke like we scroll the
                        %first line up out of the visible range of the box,
                        %thus making room for new line!
                        numscrolledlines=numscrolledlines+1;
                        
                        FilledRect(window, white, [r(1)+2 r(2)+2 r(3)-2 r(4)-2]); %clear responsebox
                        Screen('Flip',window,[],1);
                        y=originaly+height;
                        offset=0;
                        
                        if wrapword
                            %remove currentword from end of formerly-current line
                            subresponse=subresponse(1:end-(length(currentword)-1)); %the additional -1 is because we've already added the new char to currentword, but that new char wasn't present yet in the formely-current line.
                        end
                        
                        subresponselines=[subresponselines subresponse]; %add the formerly-current line to the end of subresponselines
                        
                        %(re)write text of 2nd thru last lines
                        offset=0;
                        for i=numscrolledlines+1:length(subresponselines)
                            WriteLeft(window, subresponselines{i}, x+offset, y, black);
                            y=y+height;
                        end
                        Screen('Flip',window,[],1);
                        
                        %so now we're to the point where we have room for a new line
                        if wrapword
                            subresponse=currentword;
                        else
                            subresponse=char;
                        end
                        WriteLeft(window, subresponse, x+offset, y, black);
                        Screen('Flip',window,[],1);
                        bounds = Screen('TextBounds',window,subresponse);
                        offset = offset + (bounds(3)-bounds(1));
                        
                        
                    else
                        % yeah there's room for a new line, so go for it.
                        % start making that new line of text right there in the
                        % box, starting with the currently inputted character.
                        
                        
                        if wrapword
                            %remove currentword from end of formerly-current line
                            subresponse=subresponse(1:end-(length(currentword)-1)); %the additional -1 is because we've already added the new char to currentword, but that new char wasn't present yet in the formely-current line.
                            %%%%DELETE CURRENTWORD from screen
                            bounds = Screen('TextBounds',window,currentword(1:end-1));
                            Screen('Preference','TextAlphaBlending', 1);
                            WriteLeft(window,currentword(1:end-1),x+offset-(bounds(3)-bounds(1)),y,white);
                            Screen('Preference','TextAlphaBlending', 0);
                            
                        end
                        
                        subresponselines=[subresponselines subresponse];
                        
                        
                        
                        if wrapword
                            subresponse=currentword;
                        else
                            subresponse=char;
                        end
                        
                        offset=0;
                        y=y+height;
                        WriteLeft(window, subresponse, x+offset, y, black);
                        Screen('Flip',window,[],1);
                        bounds = Screen('TextBounds',window,subresponse);
                        offset = offset + (bounds(3)-bounds(1));
                    end
                end
            end
    end
end


%concatenate all lines of subject response
subresponselines=[subresponselines subresponse];
subresponse='';

for i=1:length(subresponselines)
    subresponse=[subresponse subresponselines{i}];
end

subresponse=strtrim(subresponse);  %trims leading and trailing whitespace

%%% clear rectangles
FilledRect(window, white, r);
FilledRect(window, white, [0,screenheight-75,screenwidth,screenheight]);
Screen('Flip',window,[],1);
FlushEvents('keyDown');


end